package com.ssgu.ws;

import java.util.Collection;

import javax.ejb.EJB;
import javax.jws.WebMethod;
import javax.jws.WebService;

import org.apache.log4j.Logger;
import org.jboss.ws.annotation.EndpointConfig;

import com.ssgu.beans.Sistema;
import com.ssgu.services.interfaces.SistemaService;

@WebService(serviceName = "SistemaWebService")
@EndpointConfig(configName = "Standard WSSecurity Endpoint")
public class SistemaWebService {

	private Logger log = Logger.getLogger(SistemaWebService.class);

	@EJB
	private SistemaService service;

	@WebMethod
	public void criarSistema(String nome, String descricao) throws Exception {

		try {
			log.info("criando um sistema no web service - " + nome);

			service.criarSistema(nome, descricao);
		} catch (Exception e) {
			log.error(e.getMessage());
			throw e;
		}
	}

	@WebMethod
	public void atualizarSistema(int idSistema, String nome, String descricao)
			throws Exception {

		try {
			log.info("criando um sistema no web service - " + nome);

			service.atualizarSistema(idSistema, nome, descricao);
		} catch (Exception e) {
			log.error(e.getMessage());
			throw e;
		}
	}

	@WebMethod
	public Collection<Sistema> buscarSistemas() throws Exception {
		Collection<Sistema> c;

		try {
			c = service.buscarSistemas();
		} catch (Exception e) {
			log.error(e.getMessage());
			throw e;
		}

		return c;
	}

	@WebMethod
	public Sistema buscaSistema(int idSistema) throws Exception {
		Sistema s;
		try {
			s = service.buscarSistema(idSistema);
		} catch (Exception e) {
			log.error(e.getMessage());
			throw e;
		}
		return s;
	}

}
